#INCLUDE "dcdialog.CH"
#INCLUDE "fileio.CH"

FUNCTION Main()

LOCAL aCountries

aCountries := { ;
  {'AF', 'Afghanistan' }, ;
  {'AL', 'Albania' }, ;
  {'DZ', 'Algeria' }, ;
  {'AX', 'Aland Islands' }, ;
  {'AS', 'American Samoa' }, ;
  {'AI', 'Anguilla' }, ;
  {'AD', 'Andorra' }, ;
  {'AO', 'Angola' }, ;
  {'AN', 'Antilles - Netherlands' }, ;
  {'AG', 'Antigua and Barbuda' }, ;
  {'AQ', 'Antarctica' }, ;
  {'AR', 'Argentina' }, ;
  {'AM', 'Armenia' }, ;
  {'AU', 'Australia' }, ;
  {'AT', 'Austria' }, ;
  {'AW', 'Aruba' }, ;
  {'AZ', 'Azerbaijan' }, ;
  {'BA', 'Bosnia and Herzegovina' }, ;
  {'BB', 'Barbados' }, ;
  {'BD', 'Bangladesh' }, ;
  {'BE', 'Belgium' }, ;
  {'BF', 'Burkina Faso' }, ;
  {'BG', 'Bulgaria' }, ;
  {'BH', 'Bahrain' }, ;
  {'BI', 'Burundi' }, ;
  {'BJ', 'Benin' }, ;
  {'BM', 'Bermuda' }, ;
  {'BN', 'Brunei Darussalam' }, ;
  {'BO', 'Bolivia' }, ;
  {'BR', 'Brazil' }, ;
  {'BS', 'Bahamas' }, ;
  {'BT', 'Bhutan' }, ;
  {'BV', 'Bouvet Island' }, ;
  {'BW', 'Botswana' }, ;
  {'BV', 'Belarus' }, ;
  {'BZ', 'Belize' }, ;
  {'KH', 'Cambodia' }, ;
  {'CM', 'Cameroon' }, ;
  {'CA', 'Canada' }, ;
  {'CV', 'Cape Verde' }, ;
  {'CF', 'Central African Republic' }, ;
  {'TD', 'Chad' }, ;
  {'CL', 'Chile' }, ;
  {'CN', 'China' }, ;
  {'CX', 'Christmas Island' }, ;
  {'CC', 'Cocos (Keeling) Islands' }, ;
  {'CO', 'Colombia' }, ;
  {'CG', 'Congo' }, ;
  {'CI', "Cote D'Ivoire (Ivory Coast)" }, ;
  {'CK', 'Cook Islands' }, ;
  {'CR', 'Costa Rica' }, ;
  {'HR', 'Croatia (Hrvatska)' }, ;
  {'CU', 'Cuba' }, ;
  {'CY', 'Cyprus' }, ;
  {'CZ', 'Czech Republic' }, ;
  {'CD', 'Democratic Republic of the Congo' }, ;
  {'DJ', 'Djibouti' }, ;
  {'DK', 'Denmark' }, ;
  {'DM', 'Dominica' }, ;
  {'DO', 'Dominican Republic' }, ;
  {'EC', 'Ecuador' }, ;
  {'EG', 'Egypt' }, ;
  {'SV', 'El Salvador' }, ;
  {'TP', 'East Timor' }, ;
  {'EE', 'Estonia' }, ;
  {'GQ', 'Equatorial Guinea' }, ;
  {'ER', 'Eritrea' }, ;
  {'ET', 'Ethiopia' }, ;
  {'FI', 'Finland' }, ;
  {'FJ', 'Fiji' }, ;
  {'FK', 'Falkland Islands (Malvinas)' }, ;
  {'FM', 'Federated States of Micronesia' }, ;
  {'FO', 'Faroe Islands' }, ;
  {'FR', 'France' }, ;
  {'FX', 'France, Metropolitan' }, ;
  {'GF', 'French Guiana' }, ;
  {'PF', 'French Polynesia' }, ;
  {'GA', 'Gabon' }, ;
  {'GM', 'Gambia' }, ;
  {'DE', 'Germany' }, ;
  {'GH', 'Ghana' }, ;
  {'GI', 'Gibraltar' }, ;
  {'GB', 'Great Britain (UK)' }, ;
  {'GD', 'Grenada' }, ;
  {'GE', 'Georgia' }, ;
  {'GR', 'Greece' }, ;
  {'GL', 'Greenland' }, ;
  {'GN', 'Guinea' }, ;
  {'GP', 'Guadeloupe' }, ;
  {'GS', 'S. Georgia and S. Sandwich Islands' }, ;
  {'GT', 'Guatemala' }, ;
  {'GU', 'Guam' }, ;
  {'GW', 'Guinea-Bissau' }, ;
  {'GY', 'Guyana' }, ;
  {'HK', 'Hong Kong' }, ;
  {'HM', 'Heard Island and McDonald Islands' }, ;
  {'HN', 'Honduras' }, ;
  {'HT', 'Haiti' }, ;
  {'HU', 'Hungary' }, ;
  {'ID', 'Indonesia' }, ;
  {'IE', 'Ireland' }, ;
  {'IL', 'Israel' }, ;
  {'IN', 'India' }, ;
  {'IO', 'British Indian Ocean Territory' }, ;
  {'IQ', 'Iraq' }, ;
  {'IR', 'Iran' }, ;
  {'IT', 'Italy' }, ;
  {'JM', 'Jamaica' }, ;
  {'JO', 'Jordan' }, ;
  {'JP', 'Japan' }, ;
  {'KE', 'Kenya' }, ;
  {'KG', 'Kyrgyzstan' }, ;
  {'KI', 'Kiribati' }, ;
  {'KM', 'Comoros' }, ;
  {'KN', 'Saint Kitts and Nevis' }, ;
  {'KP', 'Korea (North)' }, ;
  {'KR', 'Korea (South)' }, ;
  {'KW', 'Kuwait' }, ;
  {'KY', 'Cayman Islands' }, ;
  {'KZ', 'Kazakhstan' }, ;
  {'LA', 'Laos' }, ;
  {'LB', 'Lebanon' }, ;
  {'LC', 'Saint Lucia' }, ;
  {'LI', 'Liechtenstein' }, ;
  {'LK', 'Sri Lanka' }, ;
  {'LR', 'Liberia' }, ;
  {'LS', 'Lesotho' }, ;
  {'LT', 'Lithuania' }, ;
  {'LU', 'Luxembourg' }, ;
  {'LV', 'Latvia' }, ;
  {'LY', 'Libya' }, ;
  {'MK', 'Macedonia' }, ;
  {'MO', 'Macao' }, ;
  {'MG', 'Madagascar' }, ;
  {'MY', 'Malaysia' }, ;
  {'ML', 'Mali' }, ;
  {'MW', 'Malawi' }, ;
  {'MR', 'Mauritania' }, ;
  {'MH', 'Marshall Islands' }, ;
  {'MQ', 'Martinique' }, ;
  {'MU', 'Mauritius' }, ;
  {'YT', 'Mayotte' }, ;
  {'MT', 'Malta' }, ;
  {'MX', 'Mexico' }, ;
  {'MA', 'Morocco' }, ;
  {'MC', 'Monaco' }, ;
  {'MD', 'Moldova' }, ;
  {'MN', 'Mongolia' }, ;
  {'MM', 'Myanmar' }, ;
  {'MP', 'Northern Mariana Islands' }, ;
  {'MS', 'Montserrat' }, ;
  {'MV', 'Maldives' }, ;
  {'MZ', 'Mozambique' }, ;
  {'NA', 'Namibia' }, ;
  {'NC', 'New Caledonia' }, ;
  {'NE', 'Niger' }, ;
  {'NF', 'Norfolk Island' }, ;
  {'NG', 'Nigeria' }, ;
  {'NI', 'Nicaragua' }, ;
  {'NL', 'Netherlands' }, ;
  {'NO', 'Norway' }, ;
  {'NP', 'Nepal' }, ;
  {'NR', 'Nauru' }, ;
  {'NU', 'Niue' }, ;
  {'NZ', 'New Zealand (Aotearoa)' }, ;
  {'OM', 'Oman' }, ;
  {'PA', 'Panama' }, ;
  {'PE', 'Peru' }, ;
  {'PG', 'Papua New Guinea' }, ;
  {'PH', 'Philippines' }, ;
  {'PK', 'Pakistan' }, ;
  {'PL', 'Poland' }, ;
  {'PM', 'Saint Pierre and Miquelon' }, ;
  {'CS', 'Serbia and Montenegro' }, ;
  {'PN', 'Pitcairn' }, ;
  {'PR', 'Puerto Rico' }, ;
  {'PS', 'Palestinian Territory' }, ;
  {'PT', 'Portugal' }, ;
  {'PW', 'Palau' }, ;
  {'PY', 'Paraguay' }, ;
  {'QA', 'Qatar' }, ;
  {'RE', 'Reunion' }, ;
  {'RO', 'Romania' }, ;
  {'RU', 'Russian Federation' }, ;
  {'RW', 'Rwanda' }, ;
  {'SA', 'Saudi Arabia' }, ;
  {'WS', 'Samoa' }, ;
  {'SH', 'Saint Helena' }, ;
  {'VC', 'Saint Vincent and the Grenadines' }, ;
  {'SM', 'San Marino' }, ;
  {'ST', 'Sao Tome and Principe' }, ;
  {'SN', 'Senegal' }, ;
  {'SC', 'Seychelles' }, ;
  {'SL', 'Sierra Leone' }, ;
  {'SG', 'Singapore' }, ;
  {'SK', 'Slovakia' }, ;
  {'SI', 'Slovenia' }, ;
  {'SB', 'Solomon Islands' }, ;
  {'SO', 'Somalia' }, ;
  {'ZA', 'South Africa' }, ;
  {'ES', 'Spain' }, ;
  {'SD', 'Sudan' }, ;
  {'SR', 'Suriname' }, ;
  {'SJ', 'Svalbard and Jan Mayen' }, ;
  {'SE', 'Sweden' }, ;
  {'CH', 'Switzerland' }, ;
  {'SY', 'Syria' }, ;
  {'SU', 'USSR (former)' }, ;
  {'SZ', 'Swaziland' }, ;
  {'TW', 'Taiwan' }, ;
  {'TZ', 'Tanzania' }, ;
  {'TJ', 'Tajikistan' }, ;
  {'TH', 'Thailand' }, ;
  {'TL', 'Timor-Leste' }, ;
  {'TG', 'Togo' }, ;
  {'TK', 'Tokelau' }, ;
  {'TO', 'Tonga' }, ;
  {'TT', 'Trinidad and Tobago' }, ;
  {'TN', 'Tunisia' }, ;
  {'TR', 'Turkey' }, ;
  {'TM', 'Turkmenistan' }, ;
  {'TC', 'Turks and Caicos Islands' }, ;
  {'TV', 'Tuvalu' }, ;
  {'UA', 'Ukraine' }, ;
  {'UG', 'Uganda' }, ;
  {'AE', 'United Arab Emirates' }, ;
  {'UK', 'United Kingdom' }, ;
  {'US', 'United States' }, ;
  {'UM', 'United States Minor Outlying Islands' }, ;
  {'UY', 'Uruguay' }, ;
  {'UZ', 'Uzbekistan' }, ;
  {'VU', 'Vanuatu' }, ;
  {'VA', 'Vatican City State' }, ;
  {'VE', 'Venezuela' }, ;
  {'VG', 'Virgin Islands (British)' }, ;
  {'VI', 'Virgin Islands (U.S.)' }, ;
  {'VN', 'Viet Nam' }, ;
  {'WF', 'Wallis and Futuna' }, ;
  {'EH', 'Western Sahara' }, ;
  {'YE', 'Yemen' }, ;
  {'YU', 'Yugoslavia (former)' }, ;
  {'ZM', 'Zambia' }, ;
  {'ZR', 'Zaire (former)' }, ;
  {'ZW', 'Zimbabwe' } }

IF CreateDatabase()
  LoadFlags2Dbf( aCountries )
ENDIF

LoadFlags2Array( aCountries )

BrowseCountries( aCountries )

RETURN nil

* ------------

STATIC FUNCTION BrowseCountries( aCountries )

LOCAL GetList[0], oBrowse, oStatic, nPointer := 1

@ 0,0 DCBROWSE oBrowse DATA aCountries SIZE 50,20 ;
      POINTER nPointer ;
      ITEMMARKED {||oStatic:setCaption(aCountries[nPointer,3])}

DCBROWSECOL ELEMENT 1 HEADER 'Abbr' WIDTH 4 PARENT oBrowse
DCBROWSECOL ELEMENT 3 HEADER 'Flag' TYPE XBPCOL_TYPE_BITMAP WIDTH 10 PARENT oBrowse
DCBROWSECOL ELEMENT 2 HEADER 'Country Name' WIDTH 30 PARENT oBrowse

@ 0,52 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP ;
       PREEVAL {|o|o:autosize := .t.} ;
       SIZE 80,20 OBJECT oStatic

DCREAD GUI FIT TITLE 'Flags of Countries'

RETURN nil

* ------------

STATIC FUNCTION CreateDatabase()

LOCAL aStru

IF File('FLAGS.DBF')
  USE FLAGS VIA 'FOXCDX' EXCL INDEX FLAGS
  RETURN .f.
ENDIF

aStru := { ;
   {'NAME','C',50,0}, ;
   {'ABBR','C',2,0}, ;
   {'FLAG','M',4,0} }

dbCreate('FLAGS.DBF',aStru,'FOXCDX')

USE FLAGS VIA 'FOXCDX' EXCL

INDEX ON ABBR TAG 'ABBR'

FLAGS->(OrdSetFocus('ABBR'))

RETURN .t.

* ------------

STATIC FUNCTION LoadFlags2Array(aCountries)

LOCAL i, cFlag, oBitmap

FOR i := 1 TO Len(aCountries)
  cFlag := aCountries[i,1]
  FLAGS->(dbSeek(cFlag))
  oBitmap := XbpBitmap():new():create()
  oBitmap:setBuffer(FLAGS->flag,XBPBMP_FORMAT_PNG)
  AAdd(aCountries[i],oBitmap)
NEXT

RETURN nil

* ------------

STATIC FUNCTION LoadFlags2DBF(aCountries)

LOCAL nHandle, i, cFlag, cBuffer, nSize

FOR i := 1 TO Len(aCountries)
  cFlag := aCountries[i,1] + '.PNG'
  nHandle := FOpen(cFlag)
  IF nHandle >= 0
    nSize := FSeek(nHandle,0,FS_END)
    cBuffer := Space(nSize)
    FSeek(nHandle,0,FS_SET)
    FRead(nHandle,@cBuffer,nSize)
    FClose(nHandle)
    FLAGS->(dbAppend())
    REPLACE FLAGS->abbr WITH aCountries[i,1], ;
            FLAGS->name WITH aCountries[i,2], ;
            FLAGS->flag WITH cBuffer
  ENDIF
NEXT

RETURN nil

* ------------

PROC dbesys

LOCAL i
LOCAL aDbes := { { "FOXDBE", .T.},;
                 { "CDXDBE", .T.}}
LOCAL aBuild :={ { "FOXCDX", 1, 2 } }

SET COLLATION TO AMERICAN
SET DATE TO AMERICAN

FOR i:= 1 TO len(aDbes)
  IF ! DbeLoad( aDbes[i][1], aDbes[i][2])
    DCMSGBOX aDbes[i][1] + ' DBE not loaded'
  ENDIF
NEXT i

FOR i:= 1 TO len(aBuild)
  IF ! DbeBuild( aBuild[i][1], aDbes[aBuild[i][2]][1], aDbes[aBuild[i][3]][1])
    DCMSGBOX aBuild[i][1] + ' DBE not Created!'
  ENDIF
NEXT i

RETURN

* ----------

PROC appsys ; RETURN
